<?php
define ( 'ACCOUNT_PHP', 1 );
define ( 'NO_AUTH_CHECK', 1 );
require_once 'includes/commons.inc.php';
require_once 'includes/index.class.php';

$tpl_error = new Template ( TPL_DIR . 'tpl_error.php' );

switch ( $action )
{
	case 'register':
	{
		// Registration disable or user is already logged in?
		if ( !$UPL['SETTINGS']['reg'] )
		{
			$tpl_message->set ( array ( 'message' => $lang_account['reg_disabled'], 'back_url' => 'index.php' ) );
			$tpl_uploader->set ( array ( 'content' => &$tpl_message, 'page_title' => $lang_titles['reg_title4'] ) );
			exit ( $tpl_uploader->display ( ) );
		}
		else if ( $UPL['USER']['logged_in'] ) exit ( header ( 'Location: index.php' ) );

		// OK to register now, start up
		$tpl_register  = new Template ( TPL_DIR . 'tpl_register.php' );
		$userinfo = gpc ( 'userinfo', 'P', array ( 'name' => '', 'email' => '', 'pbrowse' => 1, 'pemail' => 0, 'pmessage' => 1 ) );
		$errors = array ( );

		// user settings
		$user_settings_db = new DB;
		if ( !$user_settings_db->open ( USER_SETTINGS ) )
		{
			exit ( 'Unable to load user settings.' );
		}
		$user_settings = $user_settings_db->all();


		// check user inputs
		$userinfo['name'] = trim ( $userinfo['name'] );
		$userinfo['email'] = trim ( $userinfo['email'] );
		if ( !isset ( $userinfo['pbrowse'] ) ) $userinfo['pbrowse'] = false;
		if ( !isset ( $userinfo['pemail'] ) ) $userinfo['pemail'] = false;
		if ( !isset ( $userinfo['pmessage'] ) ) $userinfo['pmessage'] = false;

		// to template
		$tpl_register->set ( 'userinfo', $userinfo );
		$tpl_register->set ( 'restrictions', $user_settings['restrictions'] );

		if ( $task == 'register' )
		{
			// Process registration
			if ( $demo ) exit ( 'Demo only!' );

			// Load indices
			$names_idx  = new Index; if ( !$names_idx->open ( NAMES_INDEX ) ) exit ( 'Unable to load index ' . NAMES_INDEX );
			$emails_idx = new Index; if ( !$emails_idx->open( EMAILS_INDEX ) ) exit ( 'Unable to load index ' . EMAILS_INDEX );
			$users_idx  = new Index; if ( !$users_idx->open ( USERS_INDEX ) ) exit ( 'Unable to load index ' . USERS_INDEX );
			//$approval_idx = new Index; if ( !$approval_idx->open ( APPROVAL_INDEX ) ) exit ( 'Unable to load index ' . APPROVAL_INDEX );

			// check username
			if ( $userinfo['name'] == '' ) $errors [] = $lang_account['reg_no_name'];
			elseif ( strlen ( $userinfo['name'] ) < $user_settings['restrictions']['name_min_len'] ) $errors [] = parse ( $lang_account['reg_short_name'], '{min_length}', $user_settings['restrictions']['name_min_len'] );
			elseif ( $user_settings['restrictions']['name_max_len'] > 0 && strlen ( $userinfo['name'] ) > $user_settings['restrictions']['name_max_len'] ) $errors [] = parse ( $lang_account['reg_long_name'], '{max_length}', $user_settings['restrictions']['name_max_len'] );
			elseif ( preg_match ( '#[^a-z0-9_]#i', $userinfo['name'] ) ) $errors [] = $lang_account['reg_bad_name'];
			elseif ( $users_idx->search ( strtolower ( $userinfo['name'] ) ) !== false ) $errors [] = $lang_account['reg_name_taken'];
			elseif ( $user_settings['restrictions']['disallowed_names'] != '' && in_array ( strtolower ( $userinfo['name'] ), explode ( ',', $user_settings['restrictions']['disallowed_names'] ) ) ) $errors [] = $lang_account['reg_disallowed_name'];

			// check password
			if ( $userinfo['pass1'] == '' ) $errors [] = $lang_account['reg_no_pass'];
			elseif ( $userinfo['pass1'] != $userinfo['pass2'] ) $errors [] = $lang_account['reg_pass_no_match'];

			// check email
			if ( $userinfo['email'] == '' ) $errors [] = $lang_account['reg_no_email'];
			elseif ( strlen ( $userinfo['email'] ) > 100 || !preg_match ( "#(.+?)\@(.+?)#i", $userinfo['email'] ) ) $errors [] = $lang_account['reg_invalid_email'];
			elseif ( $emails_idx->search ( strtolower ( $userinfo['email'] ) ) !== false ) $errors [] = $lang_account['reg_email_exists'];

			// Any errors before creating user?
			if ( count ( $errors ) == 0 )
			{
				// OK, save

				// generate userid
				$userid = $names_idx->get_count ( ) == 0 ? 1 : current ( $names_idx->get_last ( ) ) + 1;

				// add user to indices
				$names_idx->insert ( $userinfo['name'], $userid );
				$emails_idx->insert ( strtolower ( $userinfo['email'] ), $userid );
				$users_idx->insert ( strtolower ( $userinfo['name'] ), $userid );

				// create user
				$newuser = new User;

				if ( $newuser->create ( $userid ) )
				{
					// User file created, open it
					$newuser->open ( $userid );

					// Set user data
					$newuser_info = array
					(
						'id'                    => $userid,
						'name'                  => $userinfo['name'],
						'password'              => md5 ( $userinfo['pass1'] ),
						'email'                 => $userinfo['email'],
						'level'                 => LEVEL_NORMAL,

						// messages
						'messages'		=> array ( ),
						'max_messages'		=> $UPL['CONFIGS']['DEFAULT_MAX_MESSAGE'],

						// user preferences
						'prf_public_browse'     => (bool)$userinfo['pbrowse'],
						'prf_public_email'	=> (bool)$userinfo['pemail'],
						'prf_private_msg'	=> (bool)$userinfo['pmessage'],

						// user status
						'is_activated'          => false,
						'is_approved'           => false,
						'is_suspended'          => false,

						// registration info
						'reg_email'             => $userinfo['email'],
						'reg_date'              => time ( ),
						'reg_ip'                => $_SERVER['REMOTE_ADDR'],

						// bandwidth
						'bw_used'               => 0,
						'bw_last_reset'         => time (),
						'bw_max'                => 1,
						'bw_reset_period'       => 30,
						'bw_auto_reset'         => 0,
						'bw_limit_notice'	=> 0, // flag to indicate whether user was added to the list of users who have exceeded bw limit. Value 0 or 1

						// storage
						'fl_max_storage'        => 1,
						'fl_max_filesize'       => 200,
						'fl_allowed_filetypes'  => 'jpg,jpeg,gif,png',
						'fl_images_only'        => true,
						'fl_allow_rename'       => 'norename',
						'fl_create_folder'      => 0,
						'fl_watermark'          => 0,
						'fl_max_folders'        => 5,

						// Extras
						'xtr_admin_comments'    => '',
						'xtr_new_email_addr'    => '', // new email address to change if code check passes
						'xtr_last_login_ip'     => '',
						'xtr_last_login_time'   => 0,
						'xtr_activation_code'   => md5 ( get_rand ( 1024 ) ), // code to activate account
						'xtr_password_code'     => md5 ( get_rand ( 1024 ) ), // code to change password
						'xtr_change_email_code' => md5 ( get_rand ( 1024 ) ), // code to change email
						'xtr_pass_attempts'	=> 0, // password reset attempts (5 max)
						'xtr_pass_last_att'	=> 0, // last attempt

					);
					// default user data
					$default_fields = $user_settings['new_user_settings'];

					$newuser->set ( $newuser_info );
					$newuser->set ( $default_fields );

					// create user folder
					if ( !make_dir ( $UPL['SETTINGS']['userfiles_dir'] . '/' . $userid, $UPL['CONFIGS']['CHMOD_TO'] ) )
					{
						// error occured, remove new user and don't save
						$newuser->remove ( $userid );
						exit ( 'Unable to create user folder for userid: ' . $userid . '. Check directory permission. Registration halted. User not registered.' );
					}

					// Activation required?
					if ( $UPL['SETTINGS']['activation_req'] )
					{
						$act_code = get_rand ( 10 );
						$newuser->set ( 'xtr_activation_code', md5 ( $act_code ) );
						$email_templates = new DB;
						if ( !$email_templates->open ( EMAIL_TEMPLATES ) )
						{
							exit ( 'Unable to open email templates' );
						}
						$message = parse ( $email_templates->get ( 'email_header' ), '{username}', $userinfo['name'] );
						$message .= parse ( $email_templates->get ( 'activation' ), '{activation_url}', $UPL['SETTINGS']['uploader_url'] . 'account.php?action=activate&userid=' . $userid . '&code=' . $act_code );
						$message .= $email_templates->get ( 'email_footer' );
						send_email ( $userinfo['email'], $lang_account['reg_act_email_subj'], $message, 'From: Uploader Admin <' . $UPL['SETTINGS']['email'] . '>' );
					}

					// auto approval?
					$newuser->set ( 'is_approved', $UPL['SETTINGS']['approval'] );

					// if auto approval is off, add user to the list of users that need approval
					if ( !$UPL['SETTINGS']['approval'] )
					{
						$approval_idx = new Index; if ( !$approval_idx->open ( APPROVAL_INDEX ) ) exit ( 'Unable to load index ' . APPROVAL_INDEX );
						$approval_idx->insert ( $userinfo['name'], $userid );
						$approval_idx->save ( );
					}

					// notify admin of new user?
					if ( $UPL['SETTINGS']['notify_reg'] )
					{
						send_email ( $UPL['SETTINGS']['email'], $lang_misc['reg_notify_email_subj'], parse ( $lang_misc['reg_notify'], '{username}', $userinfo['name'] ), 'From: Uploader Admin <' . $UPL['SETTINGS']['email'] . '>' );
					}

					// save everything
					$names_idx->save ( );
					$emails_idx->save( );
					$users_idx->save ( );
					$newuser->save ( );

                    // All done, success
					$msg [] = parse ( $lang_account['reg_success1'], '{username}', $userinfo['name'] );
					if ( $UPL['SETTINGS']['activation_req'] ) $msg [] = parse ( $lang_account['reg_success2'], '{email}', $userinfo['email'] );
					if ( !$UPL['SETTINGS']['approval'] ) $msg [] = $lang_account['reg_success3'];

					$tpl_message->set ( 'message', implode ( ' ', $msg ) );
					$tpl_message->set ( 'back_url', 'account.php?action=login' );
					$tpl_uploader->setr ( 'content', $tpl_message );
					$tpl_uploader->set ( 'page_title', $lang_titles['reg_title3'] );
					$tpl_uploader->display ( );
				}
				else
				{
					exit ( 'Unable to create user data file for userid: ' . $userid . '. Perhaps the data directory was not CHMODed correctly. Refer to the installation guide.' );
				}
			}
			else
			{
				// Display form along with error messages
				$tpl_error->setr ( 'error', $errors );
				$tpl_register->setr ( 'error', $tpl_error );
				$tpl_uploader->set ( array ( 'content' => &$tpl_register, 'page_title' => $lang_titles['reg_title2'] ) );
				$tpl_uploader->display ( );
			}
		}
		else
		{
			// Display form to user
			$tpl_uploader->set ( array ( 'content' => &$tpl_register, 'page_title' => $lang_titles['reg_title1'], 'errors' => $errors ) );
			$tpl_uploader->display ( );
		}
	}
	break;

	case 'checkname':
	{
		// name and output mode
		$name 	= trim ( gpc ( 'name', 'G' ) );
		$simple = gpc ( 'simple', 'G', false );

		// check if username is taken
		if ( $name == '' )
		{
			$result = $lang_account['chk_no_name'];
		}
		else
		{
			$users_idx = new Index;
			$users_idx->open ( USERS_INDEX );
			$result = parse ( ( $users_idx->search ( strtolower ( $name ) ) === false ? $lang_account['chk_avail'] : $lang_account['chk_taken'] ) , '{username}', htmlentities ( $name ) );
		}

		if ( $simple )
		{
			// simple output
			print $result;
		}
		else
		{
			// display it as an uploader message
			$tpl_message->set ( array ( 'message' => $result, 'back_url' => 'javascript:history.go(-1)' ) );
			$tpl_uploader->setr ( 'content', $tpl_message );
			$tpl_uploader->display ( );
		}
	}
	break;

	case 'resend_activation':
	{
		$tpl_act = new Template ( TPL_DIR . 'tpl_activate.php' );
		$err = 'none';

		if ( $task == 'activate' )
		{
			if ( $demo ) exit ( 'Demo only!' );
			// get inputs
			$email = trim ( gpc ( 'email', 'P', '' ) );

			if ( $email == '' )
			{
				$err = $lang_account['act_no_email'];
			}
			else
			{
				// find user from the emails index
				$emails_idx = new Index;
				$emails_idx->open ( EMAILS_INDEX );
				$userid = $emails_idx->search ( strtolower ( $email ) );

				if ( $userid === false )
				{
					$err = $lang_account['act_email_not_found'];
				}
				else
				{
					$user = new User;

					if ( $user->open ( $userid ) )
					{
						if ( $user->get ( 'is_activated' ) )
						{
							$err = $lang_account['act_already_activated'];
						}
						else
						{
							// generate new activation code and send it to the user
							$act_code = get_rand ( 20 );
							$user->set ( 'xtr_activation_code', md5 ( $act_code ) );
							$email_templates = new DB;
							if ( !$email_templates->open ( EMAIL_TEMPLATES ) )
							{
								exit ( 'Unable to open email templates' );
							}
							$message = parse ( $email_templates->get ( 'email_header' ), '{username}', $user->get ( 'name' ) );
							$message .= parse ( $email_templates->get ( 'activation' ), '{activation_url}', $UPL['SETTINGS']['uploader_url'] . 'account.php?action=activate&userid=' . $userid . '&code=' . $act_code );
							$message .= $email_templates->get ( 'email_footer' );
							send_email ( $user->get ( 'email' ), $lang_account['reg_act_email_subj'], $message, 'From: Uploader Admin <' . $UPL['SETTINGS']['email'] . '>' );
						}
						$user->save ( );
					}
					else
					{
						exit ( 'Unable to load user data for userid ' . $userid );
					}
				}
			}

			// errors?
			if ( $err == 'none' )
			{
				// success
				$tpl_message->set ( 'message', $lang_account['act_email_sent'] );
				$tpl_message->set ( 'back_url', 'account.php?action=login' );
				$tpl_uploader->setr ( 'content', $tpl_message );
				$tpl_uploader->display ( );
			}
			else
			{
				// display form again with errors
				$tpl_error->set ( 'error', $err );
				$tpl_act->setr( 'error', $tpl_error );
				$tpl_uploader->set ( 'page_title', $lang_misc['error'] );
				$tpl_uploader->setr ( 'content', $tpl_act );
				$tpl_uploader->display ( );
			}

		}
		else
		{
			// display form
			$tpl_uploader->setr ( 'content', $tpl_act );
			$tpl_uploader->set ( 'page_title', $lang_titles['act_title1'] );
			$tpl_uploader->display ( );
		}
	}
	break;

	case 'activate':
	{
		$userid   = gpc ( 'userid', 'G', 0 );
		$act_code = gpc ( 'code',   'G', '' );
		$user     = new User;

		if ( $user->open ( $userid ) )
		{
			$chk_code = $user->get ( 'xtr_activation_code' );

			if ( $user->get ( 'is_activated' ) )
			{
				$err = $lang_account['act_already_activated'];
			}
			elseif ( $chk_code != '' && $act_code != '' && $chk_code == md5 ( $act_code ) )
			{
				$user->set ( 'is_activated', 1 );
				$err = parse ( $lang_account['act_activated'], '{username}', $user->get ( 'name' ) );
			}
			else
			{
				$err = $lang_account['act_invalid_code'];
			}
			$user->save ( );
		}
		else
		{
			$err = $lang_account['act_invalid_user'];
		}
		$tpl_message->set ( 'message', $err );
		$tpl_uploader->setr ( 'content', $tpl_message );
		$tpl_uploader->display ( );
	}
	break;

	case 'password':
	{
		$tpl_pass = new Template ( TPL_DIR . 'tpl_password.php' );

		if ( $task == 'password' )
		{
			if ( $demo ) exit ( 'Demo only!' );
			// Get user info
			$email = trim ( gpc ( 'email', 'P' ) );
			$err = 'none';

			if ( $email == '' )
			{
				$err = $lang_account['pass_no_email'];
			}
			else
			{
				// search for user from the emails index
				$emails_idx = new Index;
				$emails_idx->open ( EMAILS_INDEX );
				$userid = $emails_idx->search ( strtolower ( $email ) );

				if ( $userid === false )
				{
					$err = $lang_account['pass_email_not_found'];
				}
				else
				{
					$user = new User;
					if ( $user->open ( $userid ) )
					{
						// generate random password code and send it to the user to make sure that the user did indeed request for password reset
						$pw_code = get_rand ( 50 );
						$user->set ( 'xtr_password_code', md5 ( $pw_code ) );
						$email_templates = new DB;
						if ( !$email_templates->open ( EMAIL_TEMPLATES ) ) { exit ( 'Unable to open email templates' ); }
						$message = parse ( $email_templates->get ( 'email_header' ), '{username}', $user->get ( 'name' ) );
						$message .= parse ( $email_templates->get ( 'password_request' ), array ( '{ip}' => $_SERVER['REMOTE_ADDR'], '{reset_url}' => $UPL['SETTINGS']['uploader_url'] . 'account.php?action=resetpassword&userid=' . $userid . '&code=' . $pw_code ) );
						$message .= $email_templates->get ( 'email_footer' );
						send_email ( $user->get ( 'email' ), $lang_account['pass_email_sub2'], $message, 'From: Uploader Admin <' . $UPL['SETTINGS']['email'] . '>' );
                                                // save it!
						$user->save ( );
					}
					else
					{
						exit ( 'Unable to load user data for userid ' . $userid );
					}
				}
			}

			// errors?
			if ( $err == 'none' )
			{
				$tpl_message->set ( 'message', parse ( $lang_account['pass_sent'], '{username}', $user->get ( 'name' ) ) );
				$tpl_message->set ( 'back_url', 'account.php?action=login' );
				$tpl_uploader->setr ( 'content', $tpl_message );
				$tpl_uploader->display ( );
			}
			else
			{
				// display form again with error messages
				$tpl_error->set ( 'error', $err );
				$tpl_pass->setr( 'error', $tpl_error );
				$tpl_uploader->set ( array ( 'page_title' => $lang_misc['error'], 'content' => &$tpl_pass ) );
				$tpl_uploader->display ( );
			}
		}
		else
		{
			// show form for user to enter email address
			$tpl_uploader->setr ( 'content', $tpl_pass );
			$tpl_uploader->display ( );
		}
	}
	break;


	case 'resetpassword':
	{
		$max_attempts = 5;
		$userid = gpc ( 'userid', 'PG', 0 );
		$code   = trim ( gpc ( 'code',   'PG', '' ) );
		$user   = new User;
		$err 	= 'none';

		// open user data file
		if ( $user->open ( $userid ) )
		{
			// check to see if user have attempted to reset too many times, this
			// is to prevent brute force attacks (hopefully)
			$attempted = $user->get ( 'xtr_pass_attempts' );
			$last_attempt = $user->get ( 'xtr_pass_last_att' );

			if ( $attempted >= $max_attempts  )
			{
				if ( ( time ( ) - $last_attempt ) < 1800 )
				{
					// max attempts reached and last attempt is too recent
					$err = $lang_account['pass_tries_exceeded'];
				}
				else
				{
					// last attempt was a while ago, ok to attempt again
					$user->set ( 'xtr_pass_attempts', 0 );
					$err = 'none';
				}
			}

			if ( $err == 'none' )
			{
				// match the user supplied code with the one in the user's data file
				// if they match, then reset the generate a random password and send it
				// to the user.
				$chk_code = $user->get ( 'xtr_password_code' );

				if ( $chk_code != '' && $chk_code == md5 ( $code ) )
				{
					// check code passed, generate new password and send it
					$pw_new = get_rand ( 10 );
					$user->set ( 'password', md5 ( $pw_new ) );
					// clear reset password code in case user resets it again
					$user->set ( 'xtr_password_code', md5 ( get_rand ( 10 ) ) );
					// clear attempts
					$user->set ( 'xtr_pass_attempts', 0 );
					$user->set ( 'xtr_pass_last_att', 0 );
					// send new password to user
					$email_templates = new DB;
					if ( !$email_templates->open ( EMAIL_TEMPLATES ) ) { exit ( 'Unable to open email templates' ); }
					$message = parse ( $email_templates->get ( 'email_header' ), '{username}', $user->get ( 'name' ) );
					$message .= parse ( $email_templates->get ( 'password_reset' ), array ( '{new_password}' => $pw_new, '{login_url}' => $UPL['SETTINGS']['uploader_url'] . 'account.php?action=login' ) );
					$message .= $email_templates->get ( 'email_footer' );

					send_email ( $user->get ( 'email' ), $lang_account['pass_email_subj'], $message, 'From: Uploader Admin <' . $UPL['SETTINGS']['email'] . '>' );
					$err = $lang_account['pass_reset'];
					$user->set ( 'password', md5 ( $pw_new ) );
					// clear reset password code
					$user->set ( 'xtr_password_code', md5 ( get_rand ( 1024 ) ) );
				}
				else
				{
					// bad code, mark this as an attempt
					$user->set ( 'xtr_pass_attempts', $user->get ( 'xtr_pass_attempts' ) + 1 );
					// set attempt time
					$user->set ( 'xtr_pass_last_att', time ( ) );
					$err = $lang_account['pass_invalid_code'];
				}
			}
			// save info
			$user->save ( );
		}
		else
		{
			$err = $lang_account['pass_invalid_user'];
		}

		// show result
		$tpl_message->set ( 'message', $err );
		$tpl_uploader->setr ( 'content', $tpl_message );
		$tpl_uploader->display ( );
	}
	break;


	case 'confirm_email_change':
	{
		$userid = gpc ( 'userid', 'G', 0 );
		$code   = gpc ( 'code', 'G', '' );
		$msg    = 'none';

		$user = new User;
		if ( $user->open ( $userid ) )
		{
			$user_code = $user->get ( 'xtr_change_email_code' );

			if ( $user_code != '' && $user_code == md5 ( $code ) )
			{
				$msg = $lang_account['email_changed'];
				// change user email and remove the code
				$old_email = $user->get ( 'email' );
				$new_email = $user->get ( 'xtr_new_email_addr' );
				$user->set ( 'email', $new_email );
				$user->set ( 'xtr_change_email_code', md5 ( get_rand ( 100 ) ) );
				$user->set ( 'xtr_new_email_addr', '' );
				$user->save ( );
				// update the index
				$emails_idx = new Index;
				if ( !$emails_idx->open( EMAILS_INDEX ) )
				{
					exit ( 'Unable to open the emails index at ' . EMAILS_INDEX );
				}
				$emails_idx->update_key ( strtolower ( $old_email ), strtolower ( $new_email ) );
				$emails_idx->save ( );
			}
			else
			{
				$msg = $lang_account['email_invalid_code'];
			}
		}
		else
		{
			$msg = $lang_account['pass_invalid_user'];
		}
		// show result
		$tpl_message->set ( 'message', $msg );
		$tpl_uploader->setr ( 'content', $tpl_message );
		$tpl_uploader->display ( );
	}
	break;


	case 'login':
	{
		// already logged in? quit
		if ( $UPL['USER']['logged_in'] )
		{
			exit ( header ( 'Location: index.php' ) );
		}

		// start up
		$tpl_login = new Template ( TPL_DIR . 'tpl_login.php' );
		$err = 'none';

		// get inputs
		$username = gpc ( 'username', 'PG', gpc ( 'uploader_username', 'C' ) );
		$password = gpc ( 'password', 'P' );
		$remember = gpc ( 'remember', 'P', true );

		// to templates
		$tpl_login->set ( 'username', $username );
		$tpl_login->set ( 'password', $password );
		$tpl_login->set ( 'remember', $remember );

		if ( $task == 'login' )
		{
			// Do login
			if ( $username == '' || $password == '' )
			{
				$err = $lang_account['log_no_input'];
			}
			else
			{
				// use index to locate user's id in order to load user info
				$users_idx = new Index;
				$users_idx->open ( USERS_INDEX );
				$userid = $users_idx->search ( strtolower ( $username ) );

				if ( $userid === false )
				{
					$err = $lang_account['log_bad_user'];
				}
				else
				{
					// user located, check user password
					$user = new User;

					if ( $user->open ( $userid ) )
					{
						if ( $user->get ( 'password' ) != md5 ( $password ) )
						{
							$err = $lang_account['log_bad_password'];
						}
					}
					else
					{
						exit ( 'Unable to open user data for userid: ' . $userid );
					}
				}
			}

			// login success?
			if ( $err == 'none' )
			{
				// set user log
				$user->set ( 'xtr_last_login_ip', $_SERVER['REMOTE_ADDR'] );
				$user->set ( 'xtr_last_login_time', time ( ) );
				$user->save ( );
				// set cookie and send user to myfiles
				$time_out = $remember ? time ( ) + 2592000 : 0;
				$domain   = $UPL['CONFIGS']['COOKIE_DOMAIN'];
				setcookie ( 'uploader_username', $username, $time_out, '/', $domain, 0 );
				setcookie ( 'uploader_userid',   $userid, $time_out, '/', $domain, 0 );
				setcookie ( 'uploader_password', md5 ( $password ), $time_out, '/', $domain, 0 );
				header ( 'Location: myfiles.php' );
			}
			else
			{
				// show login form with errors
				$tpl_error->set ( 'error', $err );
				$tpl_login->setr( 'error', $tpl_error );
				$tpl_uploader->set ( array ( 'page_title' => $lang_titles['log_title1'], 'content' => &$tpl_login ) );
				$tpl_uploader->display ( );
			}
		}
		else
		{
			// show login form
			$tpl_uploader->set ( array ( 'page_title' => $lang_titles['log_title2'], 'content' => &$tpl_login ) );
			$tpl_uploader->display ( );
		}
	}
	break;


	case 'logout':
	{
		// clear all cookies
		$dm = $UPL['CONFIGS']['COOKIE_DOMAIN'];
		setcookie ( 'uploader_username', '', -1, '/', $dm );
		setcookie ( 'uploader_userid', '', -1, '/', $dm );
		setcookie ( 'uploader_password', '', -1, '/', $dm );
		header ( 'Location: account.php?action=login' );
	}
	break;
}
?>