<?php
/*
  Unless specified, 1 means yes/on and 0 means no/off
*/
$UPL['CONFIGS'] = array
(
	// THE TIME FORMAT USED TO DISPLAY FILE UPLOAD DATE
	'TIME_FORMAT'   	=> 'm/d/y h:mA',

	// Other time formats
	'TIME_FORMAT2'  	=> 'm/d/y h:iA',

	// Simple time format
	'TIME_FORMAT3'		=> 'M d, Y',

	// SET THE DOMAIN PARAMETER OF COOKIES SET BY THE UPLOADER, IN MOST CASES YOU'D WANT TO LEAVE THIS ALONE
	'COOKIE_DOMAIN' 	=> NULL,

	// MUST BE IN THIS FORMAT 0xxx where x is an octal number. If 0755 doesn't work, use 0777 or 0666
	'CHMOD_TO'		=> 0777,

	// Set the position of the watermark image to either top of bottom of the original image. 1 for TOP, 0 for Bottom
	'WATERMARK_TOP'		=> 0,

	// Same as above, 1 for left, 0 for right.
	'WATERMARK_LEFT'	=> 0,

	// max folder name length
	'FOLDER_MAX_LEN'        => 30,

	// min folder name length, should be at least 1
	'FOLDER_MIN_LEN'        => 4,

	// max file name length including the extension
	'FILE_MAX_LEN'          => 80,

	// min file name length including extension, should be at least 5
	'FILE_MIN_LEN'          => 5,

	// default file list sorting: 'none', 'name', 'type', 'size', 'date'
	// Note: the default template tpl_myfiles.php sorts the files by date through javascript, so this option doesn't apply unless
	// you disable the sorting by editing myfiles.js.
	'DEFAULT_FILE_SORT_BY'	=> 'none',

	// default file list sorting order: 'asc' or 'dsc'
	// Note: same as the setting above, you must disable the javascript sorting in order for this setting to apply.
	'DEFAULT_FILE_SORT_ORDER'=> 'asc',

	// invalid characters in file name. Regex pattern
	'REGEX_INVALID_CHARS'	=> '#[\\\/\:\*\?\<\>\|\"]#',

	// These folder names are reserved. Users cannot rename or create folders with this name.
    // Enter folder names in lower case, checking will be case-INSENSITIVE.
	'RESERVED_FOLDERNAMES'	=> array ( 'thumbnails', 'main folder' ),

	// Default message inbox size
	'DEFAULT_MAX_MESSAGE'	=> 20,

	// How many users to show per page on the Browse page.
	'USERLIST_PERPAGE'	=> 25,

	// Width of thumbnails after upload, height will be adjusted
	'THUMBNAIL_WIDTH'	=> 150,

	// Add border with original image info (dimension and width) to thumbnails?
	// This applies to any thumbnail created, either during upload or manual resize by user.
	'THUMBNAIL_BORDER'	=> 0,

	// Skip watermarking images with width less than this (in pixels)
	'WATERMARK_IGNORE_WIDTH'	=> 200,
);
?>