<?php
$lang_misc = array
(
	'main_folder'		=> 'Main Folder',
	'error'			=> 'Error',
	'unlimited'		=> 'Unlimited',
	'reg_notify'		=> "This is an automatic notification from the uploader.\nA new user \"{username}\" has registered for an account.",
	'reg_notify_email_subj' => 'Uploader - New user notification',
	'login_required'	=> 'You need to be logged in to view this page.',
	'user_not_found'	=> 'Sorry but we were unable to locate that user.',
	'user_invalid'		=> 'Invalid user specified.',
	'email_hidden'		=> 'Not visible'
);


$lang_titles = array
(
	'error'			=> 'Error',
	'reg_title1'		=> 'User Registration',
	'reg_title2'		=> 'Registration Errors',
	'reg_title3'		=> 'Registration Successul',
	'reg_title4'		=> 'Registration Disabled',
	'mf_title1'		=> 'My Files',
	'mf_fld_title1'		=> 'Rename folder',
	'mf_fld_title2'		=> 'Manage folders',
	'mf_img_title1'		=> '[IMG] Tags',
	'act_title1'		=> 'Account activation',
	'log_title1'		=> 'Login error',
	'log_title2'		=> 'Login required',
	'ucp_title1'		=> 'UserCP',
);

$lang_commons = array
(
	'not_logged_in'		=> 'You are not logged in. Please <a href="account.php?action=login" class="special">login now</a> or <a href="account.php?action=register" class="special">register</a> if you do not have an account.',
	'account_suspended'	=> 'Your account has been suspended.',
	'account_not_activated'	=> 'Your account has not been activated. If you did not receive an activation email, <a href="account.php?action=resend_activation">click here</a>.',
	'account_not_approved'	=> 'Your account has not been approved yet, you cannot access the uploader at this time.',
);


if ( defined ( 'ACCOUNT_PHP' ) )
{
	$lang_account = array
	(
		'reg_disabled'		=> 'Registration has been disabled.',
		'reg_no_name'		=> 'Please enter a username.',
		'reg_short_name'	=> 'Your name must be at least {min_length} characters long.',
		'reg_long_name'		=> 'Your name cannot be longer than {max_length} characters long.',
		'reg_bad_name'		=> 'The name you entered contains one or more illegal characters. Please use letters and numbers only. Undercores are permitted, e.g. "john_doe".',
		'reg_name_taken'	=> 'The name you entered has been taken. Try a different name.',
		'reg_disallowed_name'	=> 'The name you entered is not allowed.',
		'reg_no_pass'		=> 'Please enter a password in both fields.',
		'reg_pass_no_match'	=> 'The passwords you entered do not match.',
		'reg_no_email'		=> 'Enter a valid working email address.',
		'reg_invalid_email'	=> 'The email address you entered appears to be invalid. Example: someone@domain.com',
		'reg_email_exists'	=> 'The email address you entered already exists in our database.',
		'reg_act_email_subj'	=> 'Account activation',
		'reg_success1'		=> 'You have been registered <strong>{username}</strong>.',
		'reg_success2'		=> 'Your account must be activated. An email has been sent to <strong>{email}</strong> containing instructions on how to activate your account.',
		'reg_success3'		=> 'Your account must be approved by the administrator. You will be notified when your account has been approved.',

		'chk_no_name'		=> 'Please enter a username.',
		'chk_avail'		=> '<span style="color:green;">{username}</span> is available!',
		'chk_taken'		=> '<span style="color:red;">{username}</span> has been taken.',

		'act_no_email'		=> 'Please enter your email address.',
		'act_email_not_found'	=> 'That email address does not exist in our database.',
		'act_already_activated'	=> 'Your account has already been activated.',
		'act_email_sent'	=> 'An email has been sent to the address you entered. Please check it for further instructions.',
		'act_activated'		=> 'Congratulation <strong>{username}</strong>, your account has been activated!',
		'act_invalid_code'	=> 'The activation code you specified is invalid.',
		'act_invalid_user'	=> 'Invalid user specified.',
		'act_email_subj'	=> 'Uploader account activation',

		'pass_email_subj'	=> 'Your password has been reset',
		'pass_email_sub2'	=> 'Your uploader password',
		'pass_no_email'		=> 'Please enter your email address.',
		'pass_email_not_found'	=> 'That email address does not exist in our database.',
		'pass_sent'		=> 'Hello <strong>{username}</strong>, an email has been sent to you. Please check it for instructions on how to reset your password.',
		'pass_reset'		=> 'Your password has been successfully reset. Please check your email.',
		'pass_invalid_code'	=> 'You did not supply a valid password reset code. To obtain a valid code, <a href="account.php?action=password" class="special">click here</a>.',
		'pass_invalid_user'	=> 'Invalid user specified.',
		'pass_tries_exceeded'	=> 'You have failed to supply a valid password reset code for more than 5 times. In order to protect the account, you will not be able to make any further attempts on this account for 30 minutes.',

		'log_no_input'		=> 'Please fill out both your username and password.',
		'log_bad_user'		=> 'That user does not exists.',
		'log_bad_password'	=> 'The password you entered is incorrect.',

		'email_invalid_code'	=> 'Invalid code specified.',
		'email_changed'		=> 'Your email address has been updated.',


	);
}


if ( defined ( 'MYFILES_PHP' ) )
{
	$lang_myfiles = array
	(
		'folder_no_exists'	=> 'Unable to access user folder for {username}. This could be due to the userfiles folder not being CHMODed correctly.',
		'folder_invalid'	=> 'The folder {folder} does not exist.',
		'no_gd'			=> 'This feature is disabled because the server does not have the required tools. Need <a href="http://www.boutell.com/gd/">GD 2.0</a>',
		'file_not_supported'	=> 'File not found or not specified.',
		'type_not_supported'	=> 'File is not an image or image type is not supported.',
		'zero_dimension'	=> 'The image dimension cannot be zero.',
		'smaller_only'		=> 'The resized image dimensions cannot be greater than or equal the original image dimensions. You can only shrink the image, not enlarge it.',
		'invalid_char_filename'	=> 'The new filename contains one or more invalid characters.',
		'invalid_char2'		=> 'The new filename contains one or more invalid characters. Use letters and numbers only.',
		'new_name_conflict'	=> 'The new image name conflicts with a folder name. Please enter a different name.',
		'resize_success'	=> 'A new image has been created. You will be taken to the image.',
		'no_resize_perm'	=> 'You do not have the permission to rename files.',
		'blank_filename'	=> 'The new filename cannot be blank',
		'alpha_prefix'		=> 'The new filename must begin with a letter or a number',
		'long_name'		=> 'The new filename cannot be greater than {length} characters in length.',
		'short_name'		=> 'File name is too short.',
		'file_exists'		=> 'There is already a file or directory with that same name. Please enter a different name.',
		'filename_only'		=> 'You cannot change the file extension. You are allowed to change only the filename.',
		'bad_extension'		=> 'You cannot rename the file to that extension.',
	);
}

if ( defined ( 'FOLDERS_PHP' ) )
{
	$lang_folders = array
	(
		'folder_invalid'	=> 'The folder {folder} does not exist.',
		'folder_bad_char'	=> 'The folder name contains invalid characters. Use letters and numbers only.',
		'folder_no_name'	=> 'Enter a folder name',
		'folder_long_name'	=> 'The folder name you entered is too long, please shorten it to within {length} characters.',
		'folder_short_name'     => 'The folder name you entered is too short. It must be at least {length} characters long.',
		'folder_exists'		=> 'The folder name you entered already exists. Please enter a different name.',
		'folder_no_perm_create'	=> 'You do not have the permission to create folders.',
		'folder_limit'		=> 'You have reached the folder limit, you cannot create more folders.',
		'folder_no_exists'	=> 'Unable to access user folder for {username}. This could be due to the userfiles folder not being CHMODed correctly.',
		'folder_name_reserved'	=> 'The foldername "{folder}" is reserved. Please enter another name.',
	);
}


if ( defined ( 'USERCP_PHP' ) )
{
	$lang_usercp = array
	(
		'ucp_no_pass'		=> 'Please enter your current password.',
		'ucp_incorrect_pass'	=> 'The password you entered is incorrect.',
		'ucp_pass_no_match'	=> 'The new passwords do not match',
		'ucp_bad_email'		=> 'The email address appears to be invalid. Expecting someone@domain.',
		'ucp_email_exists'	=> 'The email you have entered already exists in our database. Please note that multiple accounts are not permitted.',
		'ucp_saved'		=> 'Your account has been updated. You may be required to login again if you have changed your password. If you have changed your email address, an email will be sent to this new address in order to verify it. Please read it for further instructions.',

		'ucp_no_user'		=> 'Please enter the name of the recipient.',
		'ucp_no_subject'	=> 'Please enter a subject.',
		'ucp_no_message'	=> 'Please enter the message you want to send.',
		'ucp_message_sent'	=> 'Message has been delivered.',
		'ucp_bad_user'		=> 'That user does not exist.',
		'ucp_message_denied'	=> 'The user <strong>{username}</strong> does not wish to receive messages.',
		'ucp_inbox_full'	=> 'The recipient\'s inbox is currently full.',
		'ucp_long_message'	=> 'Your message is too long, please shorten it.',
		'ucp_long_subject'	=> 'Your subject is too long, please shorten it.',
		'ucp_email_subject'	=> 'Email change confirmation required',
		'ucp_bad_id'		=> 'Invalid message ID',
	);
}


if ( defined ( 'UPLOAD_PHP' ) )
{
	$lang_upload = array
	(
		'upl_folder_no_exists'	=> 'Unable to access user folder for {username}. This could be due to the userfiles folder not being CHMODed correctly.',
		'upl_storage_limit'	=> 'You have reached the storage limit on your account. Delete old files to make room.',
		'upl_partial_upload'	=> '{filename} was partially uploaded and discarded.',
		'upl_empty_file'	=> '{filename} is empty or invalid.',
		'upl_php_exceed'	=> '{filename} exceeds PHP\'s max_file_size limit of {max_file_size} and was not uploaded.',
		'upl_storage_full'	=> '{filename} was not uploaded because you have reached the storage limit on your account.',
		'upl_bad_extension'	=> '{filename}, this extension is not allowed.',
		'upl_ext_not_alllowed'	=> '{filename}, you are not allowed to upload this file type.',
		'upl_bad_chars'		=> '{filename}, file name contains invalid character(s).',
		'upl_bad_name_start'	=> '{filename}, file name must start with a letter or a number.',
		'upl_max_size'		=> '{filename}, file size exceeds your limit of {max_file_size}.',
		'upl_not_image'		=> '{filename} does not appear to be a valid image file (JPEG, PNG, BMP, and GIF). You can only upload images.',
		'upl_file_exists_warn'	=> '<strong>Warning</strong>: The file <span style="color:#888888;">{file}</span> already exists in <span style="color:#888888;">{folder}</span>.<br />',
		'upl_cant_move'		=> 'Unable to move {file} to user folder.',
		'upl_skipped'		=> 'The file "{filename}" exists and was skipped.',
	);
}

if ( defined ( 'BROWSE_PHP' ) )
{
	$lang_browse = array
	(
		'no_public_folders'	=> 'Sorry but {user} does not have any public folders for you to browse.',
		'bad_folder'		=> 'The folder you requested does not exist or it is not a public folder.',
	);
}
?>