<?php
error_reporting ( E_ALL );
define ( 'CHMOD_VALUE', 0777 );
ob_start();
set_magic_quotes_runtime ( 0 );
require_once 'includes/constants.inc.php';
require_once 'includes/db.class.php';
require_once 'includes/index.class.php';
require_once 'includes/functions.inc.php';

if ( get_magic_quotes_gpc ( ) )
{
    $_GET = strip_gpc ( $_GET );
    $_POST = strip_gpc ( $_POST );
}

function file_perm ( $path )
{
    return substr ( sprintf ( '%o', fileperms ( $path ) ), -4);
}

function get_dir_status ( $path )
{
    return is_writable ( $path ) ? 'OK (' . file_perm ( $path ) . ')' : 'Please CHMOD ' . $path . ' to 0' . decoct ( CHMOD_VALUE );
}

function get_file_status ( $file )
{
    if ( !is_file ( $file ) )
    {
	if ( !touch ( $file ) )
	{
	    return 'File does not exist and attempt to create it has failed. Please create ' . $file . ' manually.';
	}
	else
	{
	    return 'OK, file was created.';
	}
    }
    elseif ( is_writable ( $file ) )
    {
	return 'OK (' . file_perm ( $file ) . ')';
    }
    else
    {
	if ( !change_mode ( $file, CHMOD_VALUE ) )
	{
	    return 'File permission changed. Reload this page to re-test.';
	}
	else
	{
	    return 'Unable to change file permission. Please CHMOD ' . $file;
	}
    }
}

$step = isset ( $_GET['step'] ) ? $_GET['step'] : 1;
?>


<?php if ( $step == 1 ) : ?>
The following directories must be CHMODed to writeable (0777, or 0755).
<table cellspadding="3" cellspacing="1" border="1">
    <tr>
	<td>Directory description</td>
	<td>Path</td>
	<td>Status</td>
    </tr>
    <tr>
	<td>Uploader logs</td>
	<td><?=LOGS_DIR?></td>
	<td><?=get_dir_status(LOGS_DIR)?></td>
    </tr>
    <tr>
	<td>Uploader settings</td>
	<td><?=UPLSETTINGS_DIR?></td>
	<td><?=get_dir_status(UPLSETTINGS_DIR)?></td>
    </tr>
    <tr>
	<td>User data</td>
	<td><?=USERDATA_DIR?></td>
	<td><?=get_dir_status(USERDATA_DIR)?></td>
    </tr>
</table>

The Installer will try to CHMOD the following files. If it does not succeed,
you will need to do so manually.
<table cellspadding="3" cellspacing="1" border="1">
    <tr>
	<td>File description</td>
	<td>Path</td>
	<td>Status</td>
    </tr>
    <tr>
	<td>Upload Settings</td>
	<td><?=UPLOADER_SETTINGS?></td>
	<td><?=get_file_status(UPLOADER_SETTINGS)?></td>
    </tr>
    <tr>
	<td>User Settings</td>
	<td><?=USER_SETTINGS?></td>
	<td><?=get_file_status(USER_SETTINGS)?></td>
    </tr>
    <tr>
	<td>Announcements</td>
	<td><?=ANNOUNCEMENT_FILE?></td>
	<td><?=get_file_status(ANNOUNCEMENT_FILE)?></td>
    </tr>
    <tr>
	<td>Email templates</td>
	<td><?=EMAIL_TEMPLATES?></td>
	<td><?=get_file_status(EMAIL_TEMPLATES)?></td>
    </tr>
    <tr>
	<td>Users index</td>
	<td><?=USERS_INDEX?></td>
	<td><?=get_file_status(USERS_INDEX)?></td>
    </tr>
    <tr>
	<td>Names index</td>
	<td><?=NAMES_INDEX?></td>
	<td><?=get_file_status(NAMES_INDEX)?></td>
    </tr>
    <tr>
	<td>Emails index</td>
	<td><?=EMAILS_INDEX?></td>
	<td><?=get_file_status(EMAILS_INDEX)?></td>
    </tr>
    <tr>
	<td>Approval index</td>
	<td><?=APPROVAL_INDEX?></td>
	<td><?=get_file_status(APPROVAL_INDEX)?></td>
    </tr>
    <tr>
	<td>Bandwidth index</td>
	<td><?=BANDWIDTH_INDEX?></td>
	<td><?=get_file_status(BANDWIDTH_INDEX)?></td>
    </tr>
</table>

If everything is OK, <a href="install.php?step=2">go to step 2</a>.
<?php endif; ?>


<?php if ( $step == 2 ):

if ( count ( $_POST ) )
{
    $settings = $_POST['settings'];

    if ( !is_dir ( $settings['userfiles_dir'] ) )
    {
	exit ( 'Error: Userfiles directory does not exist.' );
    }
    elseif ( !is_writable ( $settings['userfiles_dir'] ) )
    {
	exit ( 'Error: Userfiles directory is not writable. Please go back, CHMOD and try again.' );
    }

    if ( !copy ( DATA_DIR . '/userfiles_htaccess.txt', $settings['userfiles_dir'] . '/.htaccess' ) )
    {
	print 'Notice: Unable to copy the file data/userfiles_htaccess.txt to the userfiles directory. Please do this manually.';
    }

    $db = new DB;
    if ( $db->open ( UPLOADER_SETTINGS ) )
    {
	$db->set ( $settings );
	$db->save ();
	print '<br />Upload settings successful! You will now be take to the next step. <a href="install.php?step=3">Click here go to there right away!</a>';
	header ( 'Refresh: 5;url=install.php?step=3' );
    }
    else exit ( 'Error: Unable to open the uploader settings file.' );
}
else { ?>
These are only the core Uploader settings. For more settings, visit the
admin section after installation. Please make sure all URLs and Paths end with a trailing slash (/).
<form method="post" action="install.php?step=2">
    <table cellspadding="3" cellspacing="1" border="1">
	<tr>
	    <td>Uploader URL</td>
	    <td>
		<input type="text" name="settings[uploader_url]" size="50" value="http://<?=$_SERVER['HTTP_HOST']?><?=dirname($_SERVER['PHP_SELF'])?>/" /><br />
		Full URL to the uploader directory. Ex: http://celerondude.com/uploader/
	    </td>
	</tr>
	<tr>
	    <td>User files directory</td>
	    <td>
		<input type="text" name="settings[userfiles_dir]" size="50" value="<?=@is_dir('files/')?realpath('files/'):''?>/" /><br />
		Full path to the user files directory where user accounts will be created. It can be anywhere on your server. The default is the "files" directory
		located in the uploader directory. Remember to CHMOD this directory!
	    </td>
	</tr>
	<tr>
	    <td>User files url</td>
	    <td>
		<input type="text" name="settings[userfiles_url]" size="50" value="<?=is_dir('files/')?'http://'.$_SERVER['HTTP_HOST'].dirname($_SERVER['PHP_SELF']).'/files/':''?>" /><br />
		The full URL to the userfiles directory.
	    </td>
	</tr>
	<tr>
	    <td>Admin email(s)</td>
	    <td>
		<input type="text" name="settings[email]" size="50" /><br />
		The email address(es) of the admin. You can enter multiple, just seperate them with a comma.
	    </td>
	</tr>
	<tr>
	    <td></td>
	    <td>
		<input type="submit" name="submit" value="Submit" />
	    </td>
	</tr>
    </table>
</form>
<?php } endif; ?>






<?php if ( $step == 3 ) :
if ( count ( $_POST ) )
{
    $userid = 1;
    $submit = $_POST['user'];

    if ( $submit['password'] != $submit['password2'] )
	exit ( 'The passwords you entered do not match. Click Back.' );

    $newuser = array
    (
	'id'                    => $userid,
	'name'                  => $submit['name'],
	'password'              => md5 ( $submit['password'] ),
	'email'                 => $submit['email'],
	'level'                 => LEVEL_ADMIN,

	// messages
	'messages'		=> array ( ),
	'max_messages'		=> 0,

	// user preferences
	'prf_public_browse'     => false,
	'prf_public_email'	=> false,
	'prf_private_msg'	=> false,

	// user status
	'is_activated'          => true,
	'is_approved'           => true,
	'is_suspended'          => false,

	// registration info
	'reg_email'             => $submit['email'],
	'reg_date'              => time ( ),
	'reg_ip'                => $_SERVER['REMOTE_ADDR'],

	// bandwidth
	'bw_used'               => 0,
	'bw_last_reset'         => time (),
	'bw_max'                => 0,
	'bw_reset_period'       => 0,
	'bw_auto_reset'         => 0,
	'bw_limit_notice'	=> 0, // flag to indicate whether user was added to the list of users who have exceeded bw limit. Value 0 or 1

	// storage
	'fl_max_storage'        => 0,
	'fl_max_filesize'       => 0,
	'fl_allowed_filetypes'  => '',
	'fl_images_only'        => false,
	'fl_allow_rename'       => 'all',
	'fl_create_folder'      => true,
	'fl_watermark'          => 0,
	'fl_max_folders'        => 0,

	// Extras
	'xtr_admin_comments'    => 'I am an admin!',
	'xtr_new_email_addr'    => '', // new email address to change if code check passes
	'xtr_last_login_ip'     => '',
	'xtr_last_login_time'   => 0,
	'xtr_activation_code'   => md5 ( get_rand ( 1024 ) ), // code to activate account
	'xtr_password_code'     => md5 ( get_rand ( 1024 ) ), // code to change password
	'xtr_change_email_code' => md5 ( get_rand ( 1024 ) ), // code to change email
	'xtr_pass_attempts'	=> 0, // password reset attempts (5 max)
	'xtr_pass_last_att'	=> 0, // last attempt
    );

    $user = new User;
    if ( $user->create ( $userid ) )
    {
	$user->open ( $userid );
	$user->set ( $newuser );
	$user->save();

	$names_idx  = new Index; if ( !$names_idx->open ( NAMES_INDEX ) ) exit ( 'Unable to load index ' . NAMES_INDEX );
	$emails_idx = new Index; if ( !$emails_idx->open( EMAILS_INDEX ) ) exit ( 'Unable to load index ' . EMAILS_INDEX );
	$users_idx  = new Index; if ( !$users_idx->open ( USERS_INDEX ) ) exit ( 'Unable to load index ' . USERS_INDEX );
	$names_idx->insert ( $newuser['name'], $newuser['id'] );
	$emails_idx->insert ( strtolower ( $newuser['email'] ), $newuser['id'] );
	$users_idx->insert ( strtolower ( $newuser['name'] ), $newuser['id'] );
	$names_idx->save ( );
	$emails_idx->save( );
	$users_idx->save ( );

	$db = new DB;

	if ( $db->open ( UPLOADER_SETTINGS ) )
	{
	    $user_root = $db->get ( 'userfiles_dir' ) . "/$userid/";

	    if ( !make_dir ( $user_root, CHMOD_VALUE ) )
	    {
		exit ( '<h1>Error!</h1><span class="red">Unable to create user directory for the admin. Please go back to Step 1.</span>' );
	    }
	}
	else
	{
	    exit ( '<h1>Error!</h1><span class="red">Unable to open the uploader settings file. Please go back to Step 1.</span>' );
	}

	print 'Congrats, installation successful. <a href="install.php?step=4">Click here</a> to remove the installer and login. If the installer fails to remove itself, please delete it manually.';

    }
    else exit ( 'Unable to create user file. Please CHMOD the directory ' . USERDATA_DIR );
}
else
{?>
<form method="post" action="install.php?step=3">
    <table cellspadding="3" cellspacing="1" border="1">
	<tr>
	    <td>Username</td>
	    <td><input type="text" name="user[name]" size="50" /></td>
	</tr>
	<tr>
	    <td>Password</td>
	    <td><input type="password" name="user[password]" size="50" /></td>
	</tr>
	<tr>
	    <td>Confirm password</td>
	    <td><input type="password" name="user[password2]" size="50" /></td>
	</tr>
	<tr>
	    <td>Email address</td>
	    <td><input type="text" name="user[email]" size="50" /></td>
	</tr>
	<tr>
	    <td></td>
	    <td><input type="submit" name="submit" value="Submit" /></td>
	</tr>
    </table>
</form>
<?php } endif; ?>


<?php if ( $step == 4 )
{
    if ( unlink ( 'install.php' ) )
    {
	header ( 'Location: account.php?action=login' );
    }
    else
    {
	exit ( 'Unable to remove install.php, please remove this file.' );
    }
}
?>