<?php /* WARNING: DO NOT EDIT ANY FORM FIELD NAMES */ ?>
<h1>Uploader Settings</h1>

<p class="p1">
    <strong class="s2">Settings for:</strong> &nbsp;
    <?=$action=='settings' ? 'Uploader' : '<a href="admin.php?action=settings" class="special">Uploader</a>'?> -
    <?=$action=='user_settings' ? 'New Users' : '<a href="admin.php?action=user_settings" class="special">New Users</a>'?> -
    <?=$action=='emails' ? 'Emails' : '<a href="admin.php?action=emails" class="special">Emails</a>'?>
</p>

<?php /* Uploader settings */ if ( $action == 'settings' ) : ?>
<?php /* If settings have been saved, display this little notification */ if ( isset ( $_GET['saved'] ) ) : ?>
<p class="note1" style="text-align:center;">All settings have been saved!</p>
<?php endif; ?>

<form action="admin.php" method="post">
    <input type="hidden" name="action" value="settings" />
    <input type="hidden" name="task" value="save" />

    <fieldset>
        <legend>Uploader Settings</legend>
        <table id="tbl1" style="width:100%;" cellpadding="5" cellspacing="1" border="0">
            <tr>
                <td colspan="2" style="line-height:1.5em;">
                    Use <a href="http://www.google.com/search?hl=en&lr=&safe=off&q=absolute+path+vs+relative+path&btnG=Search">absolute path</a> if you are specifying a directory or a URL that is <strong>outside</strong> of the Uploader directory.
                    For all paths and URLs, add a trailing slash at the end. Instead of <span style="color:#707070">/some/path</span> enter
                    <span style="color:#707070">/some/path/</span>
                </td>
            </tr>
	    <tr>
		<td colspan="2" style="line-height:1.5em;">Absolute path to the uploader directory appears to be: <?=$uploader_absolute_path?></td>
	    </tr>
            <tr>
                <td style="width:120px;">Uploader URL</td>
                <td>
                    <input type="text" name="settings[uploader_url]" value="<?=$settings['uploader_url']?>" size="75" />
                    <span class="help" onclick="help('URL to the uploader directory. This URL will be used to generate urls to different parts of the uploader. Example: http://celerondude.com/uploader/');">Explain</span>
                </td>
            </tr>
            <tr>
                <td>Userfiles Directory</td>
                <td>
                    <input type="text" name="settings[userfiles_dir]" value="<?=$settings['userfiles_dir']?>" size="75" />
                    <span class="help" onclick="help('Path to the directory where user folders will be created. If folder is outside of the uploader directory, enter the absolute path. Example: /home/public_html/uploader/userfiles/.');">Explain</span>
                </td>
            </tr>
            <tr>
                <td>Userfiles URL</td>
                <td>
                    <input type="text" name="settings[userfiles_url]" value="<?=$settings['userfiles_url']?>" size="75" />
                    <span class="help" onclick="help('The full URL to the directory above. Example: http://celerondude.com/uploader/userfiles/');">Explain</span>
                </td>
            </tr>
            <tr>
                <td style="width:120px;">Admin Emails</td>
                <td><input type="text" name="settings[email]" value="<?=$settings['email']?>" size="75" /> <span class="help" onclick="help('Email address(es) of the admin. All notifications will be sent to this email address. You can enter more than one email address by seperating them with a comma: one@celerondude.com, two@celerondude.com, three@celerondude.com.... Emails will be sent to all addresses entered.');">Explain</span></td>
            </tr>
            <tr>
                <td>Uploader Template</td>
                <td><input type="text" name="settings[tpl]" value="<?=$settings['tpl']?>" size="75" /> <span class="help" onclick="help('The directory name of the template folder located in the \'templates\' directory. If the template is not found, the default template (default) will be used so that you can fix any errors.');">Explain</span></td>
            </tr>
            <tr>
                <td>Watermark file</td>
                <td>
                    <input type="text" name="settings[wm_path]" value="<?=$settings['wm_path']?>" size="75" />
                    <span class="help" onclick="help('The path to the watermark image that is used to watermark user uploaded images. Watermarking can be disabled in the section below.');">Explain</span>
                </td>
            </tr>
            <tr>
                <td>Illegal Filetypes</td>
                <td>
                    <input type="text" name="settings[filetypes]" value="<?=$settings['filetypes']?>" size="75" />
                    <span class="help" onclick="help('File types that the users cannot upload. This setting overrides the setting for individual users. Warning: You should not leave this field blank. Enter all known file extensions that your server might parse and execute (such as ASP, PHP, Perl, or HTACCESS files). Seperate them with a comma but do not put a space in between. Example: php,pl,cgi,asp');">Explain</span>
                </td>
            </tr>
            <tr>
                <td>Upload record</td>
                <td colspan="2">
                    <input type="radio" name="settings[log]" value="2" id="log2" <?=$settings['log']==2?'checked="checked"':''?> class="radio" /><label for="log2">Log all uploads and deletions by users</label><br />
                    <input type="radio" name="settings[log]" value="1" id="log1" <?=$settings['log']==1?'checked="checked"':''?> class="radio" /><label for="log1">Log uploads only</label><br />
                    <input type="radio" name="settings[log]" value="0" id="log0" <?=$settings['log']==0?'checked="checked"':''?> class="radio" /><label for="log0">Neither (disabled)</label>
                </td>
            </tr>
            <tr>
                <td style="width:120px;">Registration</td>
                <td>
                    <input type="checkbox"  name="settings[reg]" value="1" <?=$settings['reg']==1?'checked="checked"':''?> id="registration" class="chkbox" />
                    <label for="registration">Enable new user registration.</label>
                    <br />
                    <input type="checkbox"  name="settings[approval]" value="1" <?=$settings['approval'] ?'checked="checked"':''?> id="approval" class="chkbox" />
                    <label for="approval">Automatically approve new accounts.</label> <span class="help" onclick="help('The uploader cannot be accessed if the user has not been approved. This allows you to manually approve new users or automatically approve all new users.');">Explain</span>
                    <br />
                    <input type="checkbox"  name="settings[activation_req]" value="1" <?=$settings['activation_req'] ?'checked="checked"':''?> id="activation"  class="chkbox"/>
                    <label for="activation">Accounts must be activated.</label> <span class="help" onclick="help('Activation requirement requires that the user account be activated through email. This is to verify that the user has entered a valid email address. Enable this if you wish to do so.');">Explain</span>
                    <br />
                    <input type="checkbox" name="settings[notify_reg]" id="notify_reg" value="1" <?=$settings['notify_reg'] ?'checked="checked"':''?> class="chkbox" />
                    <label for="notify_reg">Notify admin(s) of new users through email.</label>
                </td>
            </tr>
            <tr>
                <td>User/file browsing</td>
                <td colspan="2">
                    <input type="radio" name="settings[browsing]" value="any" class="radio" id="browsing1" <?=$settings['browsing']=='any'?'checked="checked"':''?>/>
                    <label for="browsing1">Anyone (public) can browse for users and browse users' files.</label>
                    <br />
                    <input type="radio" name="settings[browsing]" value="reg" class="radio" id="browsing2" <?=$settings['browsing']=='reg'?'checked="checked"':''?>/>
                    <label for="browsing2">Only registered users can use this feature.</label>
                </td>
            </tr>
            <tr>
                <td>Watermarking</td>
                <td>
                    <input type="radio" name="settings[wm]" value="always" id="wm2" <?=$settings['wm']=='always'?'checked="checked"':''?> class="radio"/><label for="wm2">Always watermark uploaded images.</label>
                    <br />
                    <input type="radio" name="settings[wm]" value="user" id="wm1" <?=$settings['wm']=='user'?'checked="checked"':''?> class="radio"/><label for="wm1">Watermark all images but allow per user setting to disable it.</label>
                    <span class="help" onclick="help('Per user setting is an individual setting for each user stating whether images uploaded by the particular user should be watermarked. Watermarking only works with JPEG and PNG formats.');">Explain</span>
                    <br />
                    <input type="radio" name="settings[wm]" value="never" id="wm0" <?=$settings['wm']=='never'?'checked="checked"':''?> class="radio"/><label for="wm0">Never watermark uploaded images.</label>
                </td>
            </tr>
        </table>
    </fieldset>

    <p style="text-align:center;">
        <input type="submit" value="Save" class="blue_button" /> <input type="reset" class="blue_button"  value="Undo changes" onclick="return confirm('Reset form?');" />
    </p>
</form>
<?php
// ######################################################################################
// THIS IS A SEPERATOR
// ######################################################################################
/* New user settings */ elseif ( $action == 'user_settings' ) : ?>
<p>
    These settings are given to new users when they register. Changing these settings will not affect currently registered users.
    To globally change settings of registered users, visit the <a href="admin.php?action=users" class="special">Users</a> section.
</p>
<br />
<?php /* If settings have been saved, display this little notification */ if ( $saved ) : ?>
<p class="note1" style="text-align:center;">All settings have been saved!</p>
<?php endif; ?>

<form action="admin.php" method="post">
    <input type="hidden" name="action" value="user_settings" />
    <input type="hidden" name="task" value="save" />

    <fieldset>
        <legend>Registration &amp; Restrictions</legend>
        <table id="tbl_rr" style="width:100%;" cellpadding="5" cellspacing="1" border="0">
            <tr>
                <td style="width:120px;">User name length</td>
                <td>
                    <input type="text" name="settings[name_min_len]" size="3" style="text-align:center;" value="<?=$settings['name_min_len']?>" /> to
                    <input type="text" name="settings[name_max_len]" size="3" style="text-align:center;" value="<?=$settings['name_max_len']?>" /> characters.
                </td>
                <td class="cr"><span class="help" onclick="help('Minimum and maximum length of user names. Min must be at least 1. Enter 0 in Max for no limit (not recommended). Naturally min has to be less than max or else the users will just be denied of registration.');">Explain</span></td>
            </tr>
            <tr>
                <td>Disallowed names</td>
                <td>
                    <input type="text" name="settings[disallowed_names]" size="75" value="<?=$settings['disallowed_names']?>" />
                </td>
                <td class="cr"><span class="help" onclick="help('List all the names that are not allowed. Seperate them with commas but leave no space between the command and the name.\nEx:admin,administrator,celerondude,bad name,uploader v6\nUser name matching is case insensitive, you do NOT have to enter both username and USERNAME.');">Explain</span></td>
            </tr>
        </table>
    </fieldset>

    <fieldset>
        <legend>File Limits &amp; Restrictions</legend>
        <table id="tbl1" style="width:100%;" cellpadding="5" cellspacing="1" border="0">
            <tr>
                <td style="width:120px;">Max storage</td>
                <td>
                    <input type="text" name="settings[fl_max_storage]" value="<?=$settings['fl_max_storage']?>" size="5" id="mst" style="text-align:center;" onkeyup=";" /> MB (enter 0 for unlimited)
                </td>
                <td class="cr"><span class="help" onclick="help('The maximum diskspace (in Megabyte) that the user can occupy.');">Explain</span></td>
            </tr>
            <tr>
                <td>Max upload file size</td>
                <td>
                    <input type="text" name="settings[fl_max_filesize]" value="<?=$settings['fl_max_filesize']?>" size="5" id="mfs" style="text-align:center;" onkeyup=";" /> KB (enter 0 for unlimited)
                </td>
                <td class="cr"><span class="help" onclick="help('The maximum file size (in Kilobyte) that the user can upload. Remember that PHP has a default size limit on uploaded files. That limit is usually 2MB. Even if you specify a value greater than the PHP default value, the user will still not be able to upload files greater than the value set by PHP. You will need to edit two PHP settings in php.ini, they are \'upload_max_filesize\' and \'post_max_size\'. You will either need to contact your webhost or edit php.ini if you are hosting yourself. Two php.ini settings have been inserted into the .htaccess file in the uploader directory (same location as index.php, admin.php, etc...) that will attempt to modify the settings mentioned above. If this method works, then you will not need to contact your web host.');">Explain</span></td>
            </tr>
            <tr>
                <td>Max folders</td>
                <td>
                    <input type="text" name="settings[fl_max_folders]" value="<?=$settings['fl_max_folders']?>" size="5" style="text-align:center;" onkeyup=";" /> folders (enter 0 for unlimited)
                </td>
                <td class="cr"><span class="help"  onclick="help('Maximum number of folders the user can create. Enter 0 for unlimited.');">Explain</span></td>
            </tr>
            <tr>
                <td>Allowed filetypes</td>
                <td>
                    <input type="text" name="settings[fl_allowed_filetypes]" value="<?=$settings['fl_allowed_filetypes']?>" size="75" />
                </td>
                <td class="cr"><span class="help" onclick="help('Specify the file types that the users are allowed to upload. Leave it blank for no limit (except for those specified in Uploader Settings).\nSeperate the extensions with commas, do NOT use spaces. Extension matching is case insensitive, you do not have to enter upper and lower case extensions.\nExample: gif,png,jpeg,zip,rar');">Explain</span></td>
            </tr>
            <tr>
                <td>Images only</td>
                <td>
                    <input type="radio" name="settings[fl_images_only]" value="1" <?=$settings['fl_images_only']==1?'checked="checked"':''?> class="radio" id="fl_images_only_1" class="chkbox" /><label for="fl_images_only_1">Images only</label><br />
                    <input type="radio" name="settings[fl_images_only]" value="0" <?=$settings['fl_images_only']==0?'checked="checked"':''?> class="radio" id="fl_images_only_2" /><label for="fl_images_only_2">Any file types</label>
                </td>
                <td class="cr"><span class="help" onclick="help('This setting will force the user to upload images only. Detecting whether the uploaded file is an image is done by reading the file, not just looking at the file extension (which can be renamed) so the Allowed Filetypes settings will be overridden by this one. For example, if you allow the user to upload .txt file but it is not an image file, it will not be uploaded.');">Explain</span></td>
            </tr>
            <tr>
                <td>File rename</td>
                <td>
                    <input type="radio" name="settings[fl_allow_rename]" value="all" <?=$settings['fl_allow_rename']=='all'?'checked="checked"':''?> class="radio"  id="fl_allow_rename_2" /><label for="fl_allow_rename_2">File name and extension</label><br />
                    <input type="radio" name="settings[fl_allow_rename]" value="nameonly" <?=$settings['fl_allow_rename']=='nameonly'?'checked="checked"':''?> class="radio" id="fl_allow_rename_1" /><label for="fl_allow_rename_1">File name only</label><br />
                    <input type="radio" name="settings[fl_allow_rename]" value="norename" <?=$settings['fl_allow_rename']=='norename'?'checked="checked"':''?> class="radio" id="fl_allow_rename_0" /><label for="fl_allow_rename_0">User cannot rename files</label>
                </td>
                <td class="cr"><span class="help" onclick="help('Allow user to rename files or not. If user is allowed to rename files, specify if the user can rename the file extension. Basically it would defeat the purpose of having file type limit when the user can rename a file that he/she is not allowed to one that is allowed (ex:EXE to JPG). Of course even if the user is allowed to rename the extension to anything, he/she cannot rename it to the extensions set in the Uploader Illegal Filetypes setting.');">Explain</span></td>
            </tr>
            <tr>
                <td>Folder creation</td>
                <td>
                    <input type="radio" name="settings[fl_create_folder]" value="1" <?=$settings['fl_create_folder']==1?'checked="checked"':''?> class="radio" id="fl_create_folder_1" /><label for="fl_create_folder_1">User can create folders</label><br />
                    <input type="radio" name="settings[fl_create_folder]" value="0" <?=$settings['fl_create_folder']==0?'checked="checked"':''?> class="radio" id="fl_create_folder_2" /><label for="fl_create_folder_2">User CANNOT create folders</label>
                </td>
                <td class="cr"><span class="help" onclick="help('Allow users to create folders. All user created folders are created inside THAT user\'s folder. For example, if a user named \'cdude\' created a folder named \'images\', the folder created would be \'userfiles/cdude/images\'');">Explain</span></td>
            </tr>
            <tr>
                <td>Image watermark</td>
                <td>
                    <input type="radio" name="settings[fl_watermark]" value="1" <?=$settings['fl_watermark']==1?'checked="checked"':''?> class="radio" id="fl_watermark1" /><label for="fl_watermark1">Watermark images uploaded by this user</label><br />
                    <input type="radio" name="settings[fl_watermark]" value="0" <?=$settings['fl_watermark']==0?'checked="checked"':''?> class="radio" id="fl_watermark2" /><label for="fl_watermark2">Do not watermark</label>
                </td>
                <td class="cr"><span class="help" onclick="help('Specify whether images uploaded by this user should be watermarked or not. This setting CAN be overridden by the global uploader setting.');">Explain</span></td>
            </tr>
        </table>
    </fieldset>

    <fieldset>
        <legend>Bandwidth Limits &amp; Restrictions</legend>
        <table id="tbl2" style="width:100%;" cellpadding="5" cellspacing="1" border="0">
            <tr>
                <td colspan="3">
                    Bandwidth limit will ONLY work if your server has <a href="http://httpd.apache.org/docs/mod/mod_rewrite.html">mod_rewrite</a> enabled and that you've edited
                    the .htaccess file found in the user files directory.
                </td>
            </tr>
            <tr>
                <td style="width:120px;">Max bandwidth</td>
                <td>
                    <input type="text" name="settings[bw_max]" value="<?=$settings['bw_max']?>" size="5" id="mbw" style="text-align:center;" /> MB
                    (<span class="link" onclick="getObj('mbw').value=1*1024">1GB</span>,
                    <span class="link" onclick="getObj('mbw').value=3*1024">3GB</span>,
                    <span class="link" onclick="getObj('mbw').value=5*1024">5GB</span>,
                    <span class="link" onclick="getObj('mbw').value=10*1024">10GB</span>,
                    <span class="link" onclick="getObj('mbw').value=15*1024">15GB</span>,
                    <span class="link" onclick="getObj('mbw').value=20*1024">20GB</span>,
                    <span class="link" onclick="getObj('mbw').value=30*1024">30GB</span>)
                </td>
                <td class="cr"><span class="help" onclick="help('Specify the maximum bandwidth (in Megabyte) allowed for the user per month. This setting only applies if bandwidth limit is enabled (see Uploader Settings). Enter 0 for unlimited.');">Explain</span></td>
            </tr>
            <tr>
                <td>Bandwidth reset period</td>
                <td>
                    <input type="text" name="settings[bw_reset_period]" value="<?=$settings['bw_reset_period']?>" size="5" id="bwrp" style="text-align:center;" /> Days
                </td>
                <td class="cr"><span class="help" onclick="help('When a user reaches his/her bandwidth limit and Bandwidth Reset Rule is set to Automatic, the uploader checks to see when was the last time the counter was reset and will only reset it after the specified time has passed.');">Explain</span></td>
            </tr>
            <tr>
                <td>Bandwidth counter reset</td>
                <td>
                    <input type="radio" name="settings[bw_auto_reset]" value="1" <?=$settings['bw_auto_reset']==1?'checked="checked"':''?> class="radio" id="bw_auto_reset_1" /><label for="bw_auto_reset_1">Automatically</label><br />
                    <input type="radio" name="settings[bw_auto_reset]" value="0" <?=$settings['bw_auto_reset']==0?'checked="checked"':''?> class="radio" id="bw_auto_reset_2" /><label for="bw_auto_reset_2">Manually (by an Admin)</label>
                </td>
                <td class="cr"><span class="help" onclick="help('When a user reaches his/her bandwidth limit, specify whether the counter should be reset automatically or manually. If manually, the user will not be able to view his/her files outside of the uploader (MyFiles) until an admin resets the counter.');">Explain</span></td>
            </tr>
        </table>
    </fieldset>

    <div style="text-align:center; margin-top:15px;">
        <input type="submit" value="Save settings" class="blue_button" /> <input type="reset" class="blue_button" value="Undo changes" onclick="return confirm('Reset form?');" />
    </div>
</form>
<?php
// ######################################################################################
// THIS IS A SEPERATOR
// ######################################################################################
/* New user settings */ elseif ( $action == 'emails' ) : ?>
<p>The following email templates are used to send messages to users. Please edit them carefully. Each email message portion may
have some variables that you can insert into. Their names are self-explanatory. Use them wherever you want the actual value to be inserted.</p>
<form id="emails_form" method="post" action="admin.php?action=emails">
    <input type="hidden" name="action" value="emails" />
    <input type="hidden" name="task" value="save" />

    <fieldset>
        <legend>Email Header &amp; Footer</legend>
        <p style="padding:5px;">
            <strong class="s1">Message header</strong><br />
            To be entered at the beginning of all emails sent to the users. Ex: "Hello username". Variables: {username}<br />
            <textarea name="emails[email_header]" rows="5" cols="105"><?=$emails['email_header']?></textarea>
        </p>
        <p style="padding:5px;">
            <strong class="s1">Message footer</strong><br />
            To be entered at the end of all emails sent to the users. Ex: "Thanks, Your name". Variables: NONE<br />
            <textarea name="emails[email_footer]" rows="5" cols="105"><?=$emails['email_footer']?></textarea>
        </p>
    </fieldset>

    <fieldset>
        <legend>Email Templates</legend>
        <p style="padding:5px;">
            <strong class="s1">Activation email</strong><br />
            Sent when user registers. Variables for this email: {activation_url}<br />
            <textarea name="emails[activation]" rows="7" cols="105"><?=$emails['activation']?></textarea>
        </p>

        <p style="padding:5px;">
            <strong class="s1">Password reset email</strong><br />
            Sent when user's password has been reset. Variables for this email: {new_password}, {login_url}<br />
            <textarea name="emails[password_reset]" rows="5" cols="105"><?=$emails['password_reset']?></textarea>
        </p>

        <p style="padding:5px;">
            <strong class="s1">Password request email</strong><br />
            Sent when user forgot his/her password. Variables for this email: {ip}, {reset_url}<br />
            <textarea name="emails[password_request]" rows="7" cols="105"><?=$emails['password_request']?></textarea>
        </p>

        <p style="padding:5px;">
            <strong class="s1">User approved email</strong><br />
            Sent when user has been approved by admin. Variables for this email: {uploader_url}<br />
            <textarea name="emails[user_approved]" rows="5" cols="105"><?=$emails['user_approved']?></textarea>
        </p>

        <p style="padding:5px;">
            <strong class="s1">"Change email" email</strong><br />
            Sent when user changes his/her email address in the UserCP. Variables for this email: {ip}, {confirm_url}<br />
            <textarea name="emails[change_email]" rows="6" cols="105"><?=$emails['change_email']?></textarea>
        </p>

        <p style="text-align:center;">
            <input type="submit" value="Save Templates" class="blue_button" />
        </p>
    </fieldset>
</form>
<?php endif; ?>




<!-- alternating row color -->
<script type="text/javascript">
    alternateRowColor(getObj('tbl1'),'tr','#F5F5F5','#FBFBFB');
    alternateRowColor(getObj('tbl2'),'tr','#F5F5F5','#FBFBFB');
    alternateRowColor(getObj('tbl_rr'),'tr','#F5F5F5','#FBFBFB');
    alternateRowColor(getObj('emails_form'),'p','#F5F5F5','#FBFBFB');
</script>